/*
 * Rodeo Calendar
 * Usage:
 * respond.calendar.setup();
 */
respond.calendar = (function () {

    return {
        version: '0.0.1',
        setup: function () {
            var calendar_rodeo, x;
            // GET
            calendar_rodeo = document.querySelectorAll('[type=calendar]');
            // SUBMIT
            
            for (x = 0; x < calendar_rodeo.length; x++) {
                respond.calendar.setupRodeoCalendar(calendar_rodeo[x]);
            }

        },
        /**
         * Setup function
         *
         */
         
        setupRodeoCalendar: function (el) {

            var format_css, calendar_display, events, api_url, container, company_name, hashtag, display_calender_detail,num_of_events,view;

            container = el.querySelector('#template_huntItemShellhunt');
            api_url = el.getAttribute('api_url');
            company_name = el.getAttribute('company_name');
            hashtag = el.getAttribute('hashtag');
            calendar_display = el.getAttribute('calendar_display');
            display_calender_detail = el.getAttribute('display_calender_detail');
            num_of_events = el.getAttribute('num_of_events');
            format_css = el.getAttribute('format_css');
            view = el.getAttribute('view');
            if (format_css === null) {
            } 
            //for Mobile size calender css selection
            else if (view =="Small"){
             var link = $("<link />", {
                    rel: "stylesheet",
                    type: "text/css",
                    href: "css/calenderMobile.css"
                })
                $('#calendar-plugin').append(link);
            }
            //for Full size calender css selection
            else {
                var link = $("<link />", {
                    rel: "stylesheet",
                    type: "text/css",
                    href:"css/calender.css"
                    // href: format_css
                })
                $('#calendar-plugin').append(link);
            }
            if (display_calender_detail === null) {
                display_calender_detail = "Yes"
            }
            if (calendar_display === null) {
                calendar_display = "Calendar"
            }
            jQuery.get(api_url, {
                company_name: company_name,
                hashtag: hashtag,
                num_of_events: num_of_events
            }, function (response) {
                var events = [];
                var listEvents = [];
                
                if (response.error) {
                    console.log(response.error);
                    return false;
                }
                
                if(response['SameDateEvents'] != null ){
                $.each(response["SameDateEvents"], function (i, event) {
                    date_array = i.split("-");
                    events.push({
                        "Date": new Date(date_array[0], date_array[1] - 1, date_array[2]),
                        "events": event,
                        "display_calender_detail": display_calender_detail,
                        "view": view
                    });
                });
                }
                
               if(response['ListViewEvents'] != null ){      
                   $.each(response["ListViewEvents"], function (i, event) {
                        date_array = i.split("-");
                        listEvents.push({
                            "Date": new Date(date_array[0], date_array[1] - 1, date_array[2]),
                            "events": event
                        });
                    });
               }
             
                if (calendar_display === "Calendar") { 
                    var settings = {};
                    var element = document.getElementById('calendar');
                    rodeo_calendar(element, events, settings);   
                } else {
                    respond.calendar.calendarDisplay(listEvents); 
                }
            });
        },

        calendarDisplay: function (events) {
           
            $('#calender-event-listing').html("");
        
               
            if (events) {
                
                for (var i = 0; i < events.length; i++) {
                    event_listing = document.querySelector('#events-list');
                    calender_event_listing = $(event_listing).clone();
                    var date_a = events[i].events[0].Date;
                    calender_event_listing.find("#gr-listing-event").append(date_a);
                    for (var j = 0; j < events[i].events.length; j++) {
                        event_time = "";
                        if (events[i].events[j].StartTime && events[i].events[j].endTime) {
                            event_time = events[i].events[j].StartTime + " - " + events[i].events[j].endTime;
                        } else if (events[i].events[j].StartTime) {
                            event_time = events[i].events[j].StartTime;
                        } else if (events[i].events[j].endTime) {
                            event_time = events[i].events[j].endTime;
                        }
                        var title_time_a = document.createElement("a");
                        title_time_a.setAttribute('href', events[i].events[j].Link);
                        title_time_a.innerHTML = events[i].events[j].Title + " ( " + event_time + " ) ";
                        title_time_a.setAttribute('target', "_blank");
                        calender_event_listing.find("#gr-listing-event").append("<br>");
                        calender_event_listing.find("#gr-listing-event").append(title_time_a);

                        $('#calender-event-listing').append(calender_event_listing);
                    }
                }
            } else {
                $('#calender-event-listing').html(" oops no events .....!");
            }
            $('#calender-event-listing #events-list').removeClass("hide");
            $('#calender-event-listing').removeClass("hide");
        }
    }

})();

respond.calendar.setup();
